#ifndef Editor2D_H
#define Editor2D_H

#include <Zeichnung.h>
#include <Schrift.h>
#include "Data.h"

using namespace Framework;

class Editor2D : public Zeichnung
{
private:
	Punkt pos;
	Punkt offs;
	Data *data;
	LRahmen *ram;
	LRahmen *select;
	Schrift *schrift;
	Punkt mausPos;
	Vertex addV;
	bool mausIn;
	float gre;
	int ref;

public:
	// Konstruktor
	Editor2D( Schrift *zSchrift );
	// Destruktor
	~Editor2D();
	// nicht constant
	void setDataZ( Data *d );
	void doMausEreignis( MausEreignis &me ) override;
	void doTastaturEreignis( TastaturEreignis &te ) override;
	bool tick( double zeit ) override;
	void render( Bild &zRObj ) override;
	// Reference Counting
	Editor2D *getThis();
	Editor2D *release();
};

#endif