#include "EditorListe.h"
#include <Rahmen.h>
#include <MausEreignis.h>
#include <Text.h>

// Inhalt der EditorListe Klasse aus EditorListe.h
// Konstruktor
EditorListe::EditorListe( Schrift *zSchrift )
{
	ram = new LRahmen();
	ram->setRamenBreite( 1 );
	ram->setFarbe( 0xFFFFFFFF );
	ram->setSize( 250, 780 );
	ram->setPosition( 740, 10 );
	scroll = new VScrollBar();
	schrift = zSchrift->getThis();
	data = 0;
	ref = 1;
}

// Destruktor
EditorListe::~EditorListe()
{
	ram->release();
	scroll->release();
	if( data )
		data->release();
	schrift->release();
}

// nicht constant
void EditorListe::setDataZ( Data *d )
{
	if( data )
		data->release();
	data = d;
}

void EditorListe::doMausEreignis( MausEreignis &me )
{
	me.mx -= ram->getX();
	me.my -= ram->getY();
	if( me.mx < 0 || me.my < 0 || me.mx > ram->getBreite() || me.my > ram->getHeight() )
	{
		me.mx += ram->getX();
		me.my += ram->getY();
		return;
	}
	scroll->doMausMessage( ram->getBreite() - 17, 1, 15, ram->getHeight() - 2, me );
	rend |= scroll->getRend();
	if( me.id == ME_RLinks )
	{
		int pAnz = data->getPolygonAnzahl();
		int y = -scroll->getScrollData()->scrollPos;
		for( int i = 0; i < pAnz; i++ )
		{
			if( me.mx > 0 && me.my > y && me.mx < 20 && me.my < y + 20 )
			{ // Ein und Ausklappen
				if( !ausgeklappt.hat( i ) )
					ausgeklappt.set( 0, i );
				ausgeklappt.set( !ausgeklappt.get( i ), i );
				rend = 1;
			}
			else if( me.mx > 215 && me.my > y + 1 && me.mx < 232 && me.my < y + 19 )
			{ // Lschen
				data->removePolygon( i );
				rend = 1;
				break;
			}
			else if( me.mx > 0 && me.my > y && me.mx < 233 && me.my < y + 20 )
			{ // Polygon Auswhlen und Abwhlen
				if( data->getSelectedPolygon() != i )
				    data->selectPolygon( i );
				else
					data->selectPolygon( -1 );
				rend = 1;
			}
			PolygonData *pd = data->zPolygon( i );
			if( pd && ausgeklappt.hat( i ) && ausgeklappt.get( i ) )
			{
				int vAnz = pd->getVertexAnzahl();
				for( int j = 0; j < vAnz; j++ )
				{
					y += 20;
					if( me.mx > 215 && me.my > y + 1 && me.mx < 232 && me.my < y + 19 )
					{ // Lschen
						pd->removeVertex( j );
						rend = 1;
					}
					else if( me.mx > 195 && me.my > y + 5 && me.mx < 205 && me.my < y + 15 )
					{ // Sichtbar und Unsichtbar
						pd->zVertex( j )->setSichtbar( !pd->zVertex( j )->istSichtbar() );
						rend = 1;
					}
					else if( me.my > y && me.my < y + 20 && me.mx > 0 && me.mx < 233 )
					{ // Auswhlen und Abwhlen
						pd->zVertex( j )->setAuswahl( !pd->zVertex( j )->istAusgewhlt() );
						rend = 1;
					}
				}
			}
			y += 20;
		}
	}
	me.verarbeitet = 1;
	me.mx += ram->getX();
	me.my += ram->getY();
}

bool EditorListe::tick( double zeit )
{
	bool ret = rend;
	rend = 0;
	return ret;
}

void EditorListe::render( Bild &zRObj )
{
	ram->render( zRObj );
	if( !zRObj.setDrawOptions( ram->getPosition() + Punkt( 1, 1 ), ram->getSize() - Punkt( 2, 2 ) ) )
		return;
	scroll->render( ram->getBreite() - 17, 1, 15, ram->getHeight() - 2, zRObj );
	int pAnz = data->getPolygonAnzahl();
	int y = -scroll->getScrollData()->scrollPos;
	int maxH = 0;
	schrift->lock();
	schrift->setSchriftSize( 12 );
	Text name;
	for( int i = 0; i < pAnz; i++ )
	{
		if( data->getSelectedPolygon() == i )
			zRObj.fillRegion( 0, y, 233, 20, 0xFF002000 );
		name = "Polygon ";
		name += i;
		schrift->setDrawPosition( 20, y + 4 );
		schrift->renderText( &name, zRObj, 0xFFFFFFFF );
		zRObj.drawLinie( Punkt( 215, y + 1 ), Punkt( 232, y + 18 ), 0xFFFF0000 );
		zRObj.drawLinie( Punkt( 232, y + 1 ), Punkt( 215, y + 18 ), 0xFFFF0000 );
		if( ausgeklappt.hat( i ) && ausgeklappt.get( i ) )
		{
			zRObj.drawDreieck( Punkt( 10, 4 + y ), Punkt( 4, 16 + y ), Punkt( 16, 16 + y ), 0xFFFFFFFF );
			PolygonData *pd = data->zPolygon( i );
			if( pd )
			{
				int vAnz = pd->getVertexAnzahl();
				for( int j = 0; j < vAnz; j++ )
				{
					maxH += 20;
					y += 20;
					if( pd->zVertex( j )->istAusgewhlt() )
						zRObj.fillRegion( 0, y, 233, 20, 0xFF101010 );
					name = "  Vertex ";
					name += j;
					schrift->setDrawPosition( 20, y + 4 );
					schrift->renderText( &name, zRObj, 0xFFFFFFFF );
					zRObj.drawLinie( Punkt( 215, y + 1 ), Punkt( 232, y + 18 ), 0xFFFF0000 );
					zRObj.drawLinie( Punkt( 232, y + 1 ), Punkt( 215, y + 18 ), 0xFFFF0000 );
					if( pd->zVertex( j )->istSichtbar() )
					{
						zRObj.drawKreis( 200, y + 10, 5, 0xFFFFFFFF );
						zRObj.drawKreis( 200, y + 10, 1, 0xFFFFFFFF );
					}
					else
					{
						zRObj.drawKreis( 200, y + 10, 5, 0xFF505050 );
						zRObj.drawKreis( 200, y + 10, 1, 0xFF505050 );
					}
				}
			}
		}
		else
			zRObj.drawDreieck( Punkt( 10, 16 + y ), Punkt( 4, 4 + y ), Punkt( 16, 4 + y ), 0xFFFFFFFF );
		maxH += 20;
		y += 20;
	}
	schrift->unlock();
	scroll->update( maxH, ram->getHeight() - 2 );
	zRObj.releaseDrawOptions();
}

// Reference Counting
EditorListe *EditorListe::getThis()
{
	ref++;
	return this;
}

EditorListe *EditorListe::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}