#ifndef GUI_H
#define HUI_H

#include <Knopf.h>
#include "EditorListe.h"
#include "Editor2D.h"

using namespace Framework;

class GUI : public Zeichnung
{
private:
	Knopf *speichern;
	Knopf *laden;
	TextFeld *pfad;
	TextFeld *name;
	Editor2D *editor;
	EditorListe *liste;
	KontrollKnopf *textur;
	TextFeld *texturPfad;
	TextFeld *texturName;
	Knopf *texturLaden;
	Knopf *texturSpeichern;
    Knopf *texturSuchen;
    Knopf *suchen;
	Data *data;
	int ref;

public:
	// Konstruktor
	GUI( Schrift *zSchrifto );
	// Destruktor
	~GUI();
	// nicht constant
	void doMausEreignis( MausEreignis &me ) override;
	void doTastaturEreignis( TastaturEreignis &te ) override;
	bool tick( double zeit ) override;
	void render( Bild &zRObj ) override;
	// Reference Counting
	GUI *getThis();
	GUI *release();
};

#endif